Package ghidra.app.util.bin.format.pef

# Class ImportedSymbol

java.lang.Object
ghidra.app.util.bin.format.pef.ImportedSymbol

All Implemented Interfaces:
  `StructConverter`

public class ImportedSymbol extends Object

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `kPEFWeakImportSymMask`
  Weak symbol mask
  `static final int`
  `SIZEOF`

  ### Fields inherited from interface ghidra.app.util.bin.StructConverter

  `ASCII, BYTE, DWORD, IBO32, IBO64, POINTER, QWORD, SLEB128, STRING, ULEB128, UTF16, UTF8, VOID, WORD`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getName()`
  Returns the symbol's name.
  `SymbolClass`
  `getSymbolClass()`
  Returns the symbol's class.
  `int`
  `getSymbolNameOffset()`
  The offset (in bytes) from the beginning of the loader string table to the null-terminated name of the symbol.
  `boolean`
  `isWeak()`
  The imported symbol does not have to be present at fragment preparation time in order for execution to continue.
  `DataType`
  `toDataType()`
  Returns a structure datatype representing the contents of the implementor of this interface.
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### SIZEOF

    public static final int SIZEOF
    See Also:
      - Constant Field Values

  - ### kPEFWeakImportSymMask

    public static final int kPEFWeakImportSymMask
    Weak symbol mask
    See Also:
      - Constant Field Values

- ## Method Details

  - ### getName

    public String getName()
    Returns the symbol's name.
    Returns:
      the symbol's name

  - ### getSymbolClass

    public SymbolClass getSymbolClass()
    Returns the symbol's class.
    Returns:
      the symbol's class

  - ### isWeak

    public boolean isWeak()
    The imported symbol does not have to be present at fragment preparation time in order for execution to continue.
    Returns:
      if the symbol is weak

  - ### getSymbolNameOffset

    public int getSymbolNameOffset()
    The offset (in bytes) from the beginning of the loader string table to the null-terminated name of the symbol.
    Returns:
      offset to the null-terminated name of the symbol

  - ### toDataType

    public DataType toDataType() throws DuplicateNameException, IOException
    Description copied from interface: `StructConverter`
    Returns a structure datatype representing the contents of the implementor of this interface.

    For example, given:

         class A {
             int foo;
             double bar;
         }

    The return value should be a structure data type with two data type components; an INT and a DOUBLE. The structure should contain field names and, if possible, field comments.

    Returns:
      returns a structure datatype representing the implementor of this interface
    Throws:
      `DuplicateNameException` - when a datatype of the same name already exists
      `IOException` - if an IO-related error occurs
    See Also:
      - `StructureDataType`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`